/*
 * buf.c
 * Copyright (C) 2010 - 2013 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "plugin.h"

buf_t *buf_init(buf_t *buf, char *rep, size_t size)
{
  if (size<2)
    goto error;

  buf->rep=rep;
  buf->mp=rep+size;
  buf->wp=rep;
  buf->wp[0]='\0';
  buf->wp[1]='\0';

  return buf;
error:
  return NULL;
}

buf_t *buf_realloc(buf_t *buf, size_t n)
{
  size_t size=buf->mp-buf->rep;
  size_t offs=buf->wp-buf->rep;

  n+=offs+2;

  if (size<n)
    goto error;

  return buf;
error:
  return NULL;
}

buf_t *buf_append_n(buf_t *buf, char *cs, size_t n)
{
  if (NULL==buf_realloc(buf,n))
    goto error;

  memcpy(buf->wp,cs,n);
  buf->wp+=n;
  buf->wp[0]='\0';
  buf->wp[1]='\0';

  return buf;
error:
  return NULL;
}

buf_t *buf_append(buf_t *buf, char *cs)
{
  return buf_append_n(buf,cs,strlen(cs));
}
